var mongoose = require('../mongoose.js')();

var schema = new mongoose.Schema({
  userId: { type: mongoose.Schema.ObjectId, require: true },
  customerId: { type: String, require: true },
  type: String,
  data: Object,
  created: { type: Date, default: Date.now },
  modified: Date,
});

schema.pre('save', function (next) {
  this.modified = new Date();
  next();
});

schema.virtual('id').get(function(){
  return this._id.toHexString();
});

schema.set('toJSON', {
  virtuals: true
});

module.exports = mongoose.model('Activity', schema);
