var mongoose = require('../mongoose.js')();

var schema = new mongoose.Schema({
  name: { type: String, require: true },
  properties: {type: Object},
  created: { type: Date, default: Date.now },
  modified: Date,
  userId: { type: mongoose.Schema.ObjectId, require: true }
});

schema.index({name: 1, userId: 1}, {unique: true});

schema.pre('save', function (next) {
  this.modified = new Date();
  next();
});

schema.virtual('id').get(function(){
  return this._id.toHexString();
});

schema.set('toJSON', {
  virtuals: true
});

module.exports = mongoose.model('Event', schema);
