var mongoose = require('../mongoose.js')();

var schema = new mongoose.Schema({
  userId: { type: mongoose.Schema.ObjectId, require: true },
  name: { type: String, require: true },
  title: { type: String },
  body: { type: String },
  created: { type: Date, default: Date.now },
  modified: { type: Date },
  static: { type: String, default: null },
  html: { type: Boolean, default: false },
});

schema.index({name: 1, userId: 1}, {unique: true});

schema.pre('save', function (next) {
  this.modified = new Date();
  next();
});

schema.virtual('id').get(function(){
  return this._id.toHexString();
});

schema.set('toJSON', {
  virtuals: true
});

module.exports = mongoose.model('Template', schema);
